/******************************************************************************************/
/******************************************************************************************/
/*                                                                                        */
/* Trigger: DTULTATU_TIPOCONSFILI                                                         */
/* Tabela : TIPOCONSFILI                                                                  */
/*                                                                                        */
/* Criao:                                                                               */
/* 20/06/2011 - Leonardo Matos                                                            */
/*                                                                                        */
/******************************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOCONSFILI'  and
            type = 'TR' and
            u.uid = o.uid and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPOCONSFILI
GO

CREATE TRIGGER DTULTATU_TIPOCONSFILI
ON TIPOCONSFILI
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOCONSFILI', CDFILIAL, 'CDFILIAL='+CDFILIAL+';CDTIPOCONS='+CDTIPOCONS+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END ELSE BEGIN
      UPDATE TIPOCONSFILI
      SET DTULTATU = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(TIPOCONSFILI.CDFILIAL ,0) = ISNULL(INSERTED.CDFILIAL ,0)) AND
            (ISNULL(TIPOCONSFILI.CDTIPOCONS,0) = ISNULL(INSERTED.CDTIPOCONS,0)) AND
            (ISNULL(TIPOCONSFILI.DSACESSOSITE,0) = ISNULL(INSERTED.DSACESSOSITE,0));
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_TIPOCONSFILI','5.20.000';
GO
